import { ModalFormData, ActionFormData } from '@minecraft/server-ui'
import { world, system } from '@minecraft/server'

//_________________________________/ Database \_________________________________\\

class DataBase {

    AnnouncementTitle = ''

    Announcement = ''

    constructor(DataBase) {
        if (!DataBase) return
        Object.assign(this, DataBase)
    }

}

class Objectives {

    GetObjective(player) {
        if (!world.scoreboard.getObjective(`Announcement_DataStorage`))
            world.scoreboard.addObjective(`Announcement_DataStorage`, `Data_Stored`)
        return world.scoreboard.getObjective(`Announcement_DataStorage`)
    }


    GetData(player) {
        let Data = []
        for (let participant of this.GetObjective(player).getParticipants()) {
            let data = new DataBase(JSON.parse(participant.displayName))
            Data.push(data)
        }
        return Data
    }

}
export const Objective = new Objectives

//_________________________________/ Menus / Other Stuff \_________________________________\\

class TESTs {
    AnnouncementAdmin(player) {
        const form = new ModalFormData()
            .textField('Announcement Title (DO NOT MAKE IT LONG)', 'Awesome Announcement')
            .textField('Whats This Announcement', 'text')

        form.show(player).then((data) => {
            if (data.canceled) return;
            system.run(() => {
                Objective.GetObjective(player).addScore(JSON.stringify(new DataBase({ AnnouncementTitle: data.formValues[0], Announcement: data.formValues[1] })), 0)
            })
        })
    }


}
export const TEST = new TESTs