import { world, system } from '@minecraft/server'
import { ActionFormData } from '@minecraft/server-ui'
import { Main } from '../community_panel/main_menu'
import { Warp_Function } from '../community_panel/private_warps'
//_________________________________/ Database \_________________________________\\

class Warps {

    Player_Location = {}

    Name = ""

    constructor(Warps) {
        if (!Warps) return
        Object.assign(this, Warps)
    }

}

class Objectives {

    GetObjective(player) {
        if (!world.scoreboard.getObjective(`Warps`))
            world.scoreboard.addObjective(`Warps`, `Data_Stored`)
        return world.scoreboard.getObjective(`Warps`)
    }


    GetData(player) {
        let Data = []
        for (let participant of this.GetObjective(player).getParticipants()) {
            let data = new Warps(JSON.parse(participant.displayName))
            Data.push(data)
        }
        return Data
    }

}
export const Objective = new Objectives

//_________________________________/ Menus / Other Stuff \_________________________________\\

class Menus {

    MainMenu(player) {
        const form = new ActionFormData()
            .button('Public Warps')
            .button('Your Warps')
        form.show(player).then((data) => {
            if (data.selection === 0) {
                this.MainMenu2(player)
            }
            if (data.selection === 1) {
                Warp_Function.MainMenu(player)
            }
        })
    }

    MainMenu2(player) {
        let Datas = Objective.GetData(player)
        const form = new ActionFormData()
        form.title('Public Warps')
        for (let i = 0; i < Datas.length; i++) {
            let Warp = Datas[i]
            form.button(`${Warp.Name}`)
        }
        form.button('Back')
        form.show(player).then((data) => {
            if (data.selection < Datas.length) {
                this.TP(player, Datas, data.selection)
            }
            if (data.selection === Datas.length) {
                Main(player)
            }
        })
    }

    TP(player, Datas, index) {
        let Warp = Datas[index]
        player.teleport(Warp.Player_Location)
    }

}
export const Menu = new Menus