import { ActionFormData } from '@minecraft/server-ui'
import { TEST } from './announcements'
import { Warp_Menus } from './warps'
import { Settings } from './admin_settings'
import { Ban_System } from './Ban_System'
import { Options } from './player_options'
import { MP } from './server_shutdown'
import { Reports } from '../community_panel/reports'

import {ToggleFeature} from './toggle_features'

export function Admin_Main(player) {
    const Value = player.getDynamicProperty("isDev")
    const form = new ActionFormData()
        .title('Admin Menu')

        .button('Public Warps', 'textures/items/ender_pearl')
        .button('Announcements', 'textures/icons/megaphone')
        .button('Ban', 'textures/blocks/barrier')
        .button('Players\n[Still In Development]', "textures/ui/FriendsIcon")
        .button('Server Shut Down', 'textures/ui/servers')
        .button('Reports', 'textures/icons/report_icon')
      //  .button('Feature Disabler')
        .button('Settings', 'textures/ui/icon_setting')
    form.show(player).then((data) => {

        if (data.selection === 0) {
            Warp_Menus.Admin_Warps(player)
        }
        if (data.selection === 1) {
            TEST.AnnouncementAdmin(player)
        }
        if (data.selection === 2) {
            Ban_System.BanType(player)
        }
        if (data.selection === 3) {
            if (Value === true) {
                Options.Player_Selector(player)
            } else {
                player.sendMessage('§c§lYOU ARE NOT A DEV')
            }
        }
        if (data.selection === 4) {
            MP.showMainMenu(player)
        }
        if (data.selection === 5) {
            Reports.AllReports(player)
        }
        /*
        if (data.selection === 6) {
            ToggleFeature(player)
        }
        */
        if (data.selection === 6) {
            Settings.Main_Menu(player)
        }
    })
}